<template>
  <div class="pa-6 white">
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-container>
        <v-row>
          <v-col md="12">
            <h2>Criar Aluno</h2>
            <h3>Dados Pessoais</h3>
          </v-col>
        </v-row>
        <v-row>
          <v-col md="6" sm="12">
            <Input
              v-model="student.name"
              label="Nome"
              :rules="[rules.required, rules.minLength(3)]"
            />
          </v-col>
          <v-col md="6" sm="12" xs="12">
            <Input
              v-model="student.email"
              label="Email"
              :rules="[rules.email]"
            />
          </v-col>
        </v-row>
        <v-row>
          <v-col md="6" sm="12" xs="12">
            <Input
              v-model="student.cpf"
              label="CPF"
              :rules="[rules.cpf]"
              mask="###.###.###-##"
              maxlength="11"
            />
          </v-col>
          <v-col md="6" sm="12" xs="12">
            <Input v-model="student.rg" label="RG" :rules="[rules.required]" />
          </v-col>
        </v-row>
        <v-row>
          <v-col md="6" sm="12">
            <Input v-model="student.cnh" label="CNH" :rules="[rules.cnh]" />
          </v-col>
          <v-col md="3" sm="6">
            <DatePicker
              v-model="student.bornDate"
              label="Data Nascimento"
              :maxDateNow="true"
            />
          </v-col>
          <v-col md="3" sm="6">
            <v-select
              v-model="student.sex"
              label="Sexo"
              :items="sex"
              item-text="label"
              item-value="value"
              required
              outlined
            ></v-select>
          </v-col>
        </v-row>
        <v-row>
          <v-col md="12"><h3>Endereço</h3></v-col>
        </v-row>
        <v-row>
          <v-col sm="12" xs="12" md="6">
            <Input
              v-model="student.number"
              label="Número"
              :rules="[rules.isNumber, rules.required, rules.positive]"
            />
          </v-col>
          <v-col sm="12" xs="12" md="6">
            <Input
              v-model="student.cep"
              label="CEP"
              :rules="[rules.required, rules.cep]"
              mask="#####-###"
            />
          </v-col>
        </v-row>
        <v-row>
          <v-col sm="12" xs="12">
            <Input
              v-model="student.address"
              label="Endereço"
              :rules="rules.name"
              disabled
            />
          </v-col>
        </v-row>
        <v-row>
          <v-col md="6" sm="12" xs="12">
            <Input v-model="student.neiborhood" label="Bairro" disabled />
          </v-col>
          <v-col md="6" sm="12" xs="12">
            <Input v-model="student.city" label="Cidade" disabled />
          </v-col>
        </v-row>
        <v-row>
          <v-col md="6" sm="12" xs="12">
            <Input
              v-model="student.cellphone"
              label="Celular"
              :rules="rules.phone"
              mask="(##) #####-####"
            />
          </v-col>
          <v-col md="6" sm="12" xs="12">
            <Input
              v-model="student.phone"
              label="Telefone"
              :rules="rules.phone"
              mask="'(##) ####-####'"
            />
          </v-col>
        </v-row>

        <v-row class="my-3 mx-1">
          <v-btn
            :disabled="!valid"
            color="success"
            class="mr-4"
            elevation="0"
            type="submit"
            @click.prevent="createStudent"
          >
            Gravar
          </v-btn>
          <v-btn class="mr-4" @click="reset" elevation="0" color="indigo" dark>
            Limpar
          </v-btn>

          <v-spacer></v-spacer>

          <v-btn elevation="0" dark @click="closeDialog" color="secondary">
            Fechar
          </v-btn>
        </v-row>
      </v-container>
    </v-form>
  </div>
</template>

<script>
import { validateCep } from "validations-br";
import cepService from "../service/cep";

import Input from "./Input.vue";
import DatePicker from "./DatePicker.vue";

import rules from "../validation";
import helpers from "../helpers";
import constants from "../constants";

export default {
  name: "StudentCreate",
  props: {
    closeDialog: Function,
  },

  components: {
    Input,
    DatePicker,
  },

  data: () => ({
    valid: false,
    rules,
    student: {
      name: "",
      email: "",
      cpf: "",
      rg: "",
      cnh: "",
      bornDate: "",
      sex: "",
      cep: "",
      address: "",
      number: "",
      neiborhood: "",
      city: "",
      state: "",
      phone: "",
      cellphone: "",
    },
    sex: constants.sex,
  }),

  methods: {
    async createStudent() {
      //TODO remove this line later
      this.student.id = this.$store.state.student.list.length + 1;

      this.$store.dispatch("createStudent", this.student);

      await this.$swal("Salvo com sucesso!", "", "success");
      this.closeDialog();
      this.reset();
    },
    reset() {
      this.$refs.form.reset();
    },
  },
  computed: {
    studentCep() {
      return this.student.cep;
    },
  },
  watch: {
    async studentCep(cep) {
      if (!cep || !validateCep(cep)) return;

      const cepNumbers = helpers.clearStringNumbers(cep);
      const address = await cepService.getAddress(cepNumbers);

      this.student.address = address.logradouro;
      this.student.city = address.localidade;
      this.student.state = address.UF;
      this.student.neiborhood = address.bairro;
    },
  },
};
</script>

<style>
</style>